## openjpeg 1.5.2

=== applications/CMakeLists.txt ===
# Build the each application if it needed

IF(BUILD_CODEC)
  ADD_SUBDIRECTORY(codec)
ENDIF(BUILD_CODEC)

IF(BUILD_MJ2)
  ADD_SUBDIRECTORY(mj2)
ENDIF(BUILD_MJ2)

# Client & Server:
IF(BUILD_JPIP)
  ADD_SUBDIRECTORY(jpip)
ENDIF(BUILD_JPIP)

IF(BUILD_VIEWER)
  ADD_SUBDIRECTORY(OPJViewer)
ENDIF(BUILD_VIEWER)

IF(BUILD_JAVA)
	ADD_SUBDIRECTORY(JavaOpenJPEG)
ENDIF(BUILD_JAVA)

=== doc/CMakeLists.txt ===
# Generate target to build the html documentation through CMake tool
# After having configured the project with the BUILD_DOC option you can run make doc
# to generate the html documentation in the doc/html repository of the build folder.

# Try to find the doxygen tool
FIND_PACKAGE(Doxygen)

IF(DOXYGEN_FOUND)
  # Configure the doxygen config file with variable from CMake and move it
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.dox.cmake.in
    ${CMAKE_BINARY_DIR}/doc/Doxyfile-html.dox @ONLY)

  # Configure the html mainpage file of the doxygen documentation with variable
  # from CMake and move it  
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/mainpage.dox.cmake
    ${CMAKE_BINARY_DIR}/doc/mainpage.dox @ONLY)

  # Generate new target to build the html documentation
  ADD_CUSTOM_TARGET(doc ALL
    ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/doc/Doxyfile-html.dox)

ELSE(DOXYGEN_FOUND)

  MESSAGE(STATUS "Doxygen not found, we cannot generate the documentation")

ENDIF(DOXYGEN_FOUND)

=== tests/CMakeLists.txt ===
# Tests
INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  ${OPENJPEG_SOURCE_DIR}/applications/codec
  ${OPENJPEG_SOURCE_DIR}/applications/common
  ${Z_INCLUDE_DIRNAME}
  ${PNG_INCLUDE_DIRNAME}
  ${TIFF_INCLUDE_DIRNAME}
  )

# First thing define the common source:
SET(comparePGXimages_SRCS comparePGXimages.c
  ${OPENJPEG_SOURCE_DIR}/applications/codec/convert.c
  )
SET(compare_dump_files_SRCS compare_dump_files.c)
SET(compareRAWimages_SRCS compareRAWimages.c)

if(NOT USE_SYSTEM_GETOPT)
  list(APPEND comparePGXimages_SRCS ${OPENJPEG_SOURCE_DIR}/applications/common/opj_getopt.c)
  list(APPEND compare_dump_files_SRCS ${OPENJPEG_SOURCE_DIR}/applications/common/opj_getopt.c)
  list(APPEND compareRAWimages_SRCS ${OPENJPEG_SOURCE_DIR}/applications/common/opj_getopt.c)
endif()

ADD_EXECUTABLE(comparePGXimages ${comparePGXimages_SRCS})
TARGET_LINK_LIBRARIES(comparePGXimages
  ${OPENJPEG_LIBRARY_NAME}
  ${PNG_LIBNAME} ${TIFF_LIBNAME}
  )
# To support universal exe:
IF(ZLIB_FOUND AND APPLE)
  TARGET_LINK_LIBRARIES(comparePGXimages z)
ELSe(ZLIB_FOUND AND APPLE)
  TARGET_LINK_LIBRARIES(comparePGXimages ${Z_LIBNAME})
ENDIF(ZLIB_FOUND AND APPLE)

ADD_EXECUTABLE(compare_dump_files ${compare_dump_files_SRCS})

ADD_EXECUTABLE(compareRAWimages ${compareRAWimages_SRCS})

# No image send to the dashboard if lib PNG is not available.
IF(NOT HAVE_LIBPNG)
  MESSAGE(WARNING "Lib PNG seems to be not available: if you want run the non-regression tests with images reported to the dashboard, you need it (try BUILD_THIRDPARTY)") 
ENDIF(NOT HAVE_LIBPNG)

ADD_SUBDIRECTORY(conformance)
ADD_SUBDIRECTORY(nonregression)
ADD_SUBDIRECTORY(unit)

IF(BUILD_JPIP)
  IF(JPIP_SERVER)
    #SET(s "http://jpip.example.com/myFCGI?target=16.jp2&fsiz=170,170&cnew=http&type=jpp-stream")
    SET(s "${JPIP_SERVER}?target=16.jp2&fsiz=170,170&cnew=http&type=jpp-stream")
    SET(p "${CMAKE_CURRENT_BINARY_DIR}/jpip.dat")
    SET(md5 "62b00c620fb0a600c5ffd413cada4674")
    ADD_TEST(NAME TestJPIP1 COMMAND ${CMAKE_COMMAND} -DD_URL:STRING=${s} -DD_FILE:PATH=${p}
      -DEXPECTED_MD5=${md5} -P ${PROJECT_SOURCE_DIR}/CMake/JPIPTestDriver.cmake)
  ENDIF(JPIP_SERVER)
ENDIF(BUILD_JPIP)

=== applications/JavaOpenJPEG/CMakeLists.txt ===
#JavaOpenJPEG/CMakeLists.txt

# First thing define the common source:
SET(openjpegjni_SRCS
  JavaOpenJPEGDecoder.c
  JavaOpenJPEG.c
  ${OPENJPEG_SOURCE_DIR}/applications/codec/index.c
  ${OPENJPEG_SOURCE_DIR}/applications/codec/convert.c
  #${OPENJPEG_SOURCE_DIR}/applications/common/color.c
  ${OPENJPEG_SOURCE_DIR}/applications/common/opj_getopt.c
  )

# JNI binding:
find_package(JNI REQUIRED)
include_directories(${JNI_INCLUDE_DIRS})

# required header file:
include_directories(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  ${OPENJPEG_SOURCE_DIR}/applications/common
  ${OPENJPEG_SOURCE_DIR}/applications/codec
  )

add_library(openjpegjni MODULE
  ${openjpegjni_SRCS}
  )
# Java module should not have a SONAME:
set_property(TARGET openjpegjni PROPERTY NO_SONAME 1)

TARGET_LINK_LIBRARIES(openjpegjni ${OPENJPEG_LIBRARY_NAME})

if(UNIX)
  target_link_libraries(openjpegjni m)
endif()

INSTALL(TARGETS openjpegjni
  EXPORT OpenJPEGTargets
  LIBRARY DESTINATION ${OPENJPEG_INSTALL_JNI_DIR} COMPONENT Libraries
)

# build jar:
FIND_PACKAGE(Java 1.5 REQUIRED) # javac, jar

# build dep list:
file(GLOB java_srcs "java-sources/org/openJpeg/*.java")

# make sure target javac dir exists:
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classes)
# Build java
ADD_CUSTOM_COMMAND(
  OUTPUT ${LIBRARY_OUTPUT_PATH}/openjpeg.jar
  COMMAND ${Java_JAVAC_EXECUTABLE} -sourcepath  "${CMAKE_CURRENT_SOURCE_DIR}/java-sources"
  ${java_srcs} -d ${CMAKE_CURRENT_BINARY_DIR}/classes
  COMMAND ${Java_JAR_EXECUTABLE} cvf ${LIBRARY_OUTPUT_PATH}/openjpeg.jar org
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classes
  DEPENDS ${java_srcs}
  COMMENT "javac *.java; jar cvf -> openjpeg.jar"
)

# name the target
ADD_CUSTOM_TARGET(OpenJPEGJavaJar ALL
  DEPENDS ${LIBRARY_OUTPUT_PATH}/openjpeg.jar
  COMMENT "building openjpeg.jar"
)

INSTALL(FILES ${LIBRARY_OUTPUT_PATH}/openjpeg.jar
  DESTINATION ${OPENJPEG_INSTALL_SHARE_DIR} COMPONENT JavaModule
)

=== applications/OPJViewer/CMakeLists.txt ===
PROJECT(viewer CXX)

FIND_PACKAGE(wxWidgets REQUIRED)
INCLUDE(${wxWidgets_USE_FILE})

INCLUDE_DIRECTORIES(
  ${CMAKE_CURRENT_SOURCE_DIR}/../..
  ${CMAKE_CURRENT_SOURCE_DIR}/..
  )

# original flags:
# -DUSE_JPWL -DwxUSE_LIBOPENJPEG -DwxUSE_GUI=1 -DOPJ_STATIC -DOPJ_HTMLABOUT -DOPJ_INICONFIG -DUSE_JPSEC -DOPJ_MANYFORMATS
ADD_DEFINITIONS(-DwxUSE_LIBOPENJPEG -DOPENJPEG_VERSION="1.5.0")
SET(OPJV_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/source/imagjpeg2000.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/wxj2kparser.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/OPJViewer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/wxjp2parser.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/OPJDialogs.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/OPJThreads.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/OPJAbout.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/../codec/index.c
  )
ADD_EXECUTABLE(opjviewer ${OPJV_SRCS})
TARGET_LINK_LIBRARIES(opjviewer ${wxWidgets_LIBRARIES} openjpeg)

=== applications/codec/CMakeLists.txt ===
# Build the demo app, small examples

# First thing define the common source:
SET(common_SRCS
  convert.c
  index.c
  ${OPENJPEG_SOURCE_DIR}/applications/common/color.c
  )
if(NOT USE_SYSTEM_GETOPT)
  list(APPEND common_SRCS
    ${OPENJPEG_SOURCE_DIR}/applications/common/opj_getopt.c
  )
endif()

# Headers file are located here:
INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  ${LCMS_INCLUDE_DIRNAME}
  ${OPENJPEG_SOURCE_DIR}/applications/common
  ${Z_INCLUDE_DIRNAME}
  ${PNG_INCLUDE_DIRNAME}
  ${TIFF_INCLUDE_DIRNAME}
  )

IF(WIN32)
  IF(BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-DOPJ_EXPORTS)
  ELSE(BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-DOPJ_STATIC)
  ENDIF(BUILD_SHARED_LIBS)
ENDIF(WIN32)

# Loop over all executables:
FOREACH(exe j2k_to_image image_to_j2k j2k_dump)
  ADD_EXECUTABLE(${exe} ${exe}.c ${common_SRCS})
  TARGET_LINK_LIBRARIES(${exe} ${OPENJPEG_LIBRARY_NAME} 
    ${PNG_LIBNAME} ${TIFF_LIBNAME} ${LCMS_LIBNAME}
    )
  # To support universal exe:
  IF(ZLIB_FOUND AND APPLE)
    TARGET_LINK_LIBRARIES(${exe} z)
  ELSe(ZLIB_FOUND AND APPLE)
    TARGET_LINK_LIBRARIES(${exe} ${Z_LIBNAME})
  ENDIF(ZLIB_FOUND AND APPLE)

  # On unix you need to link to the math library:
  IF(UNIX)
    TARGET_LINK_LIBRARIES(${exe} m)
  ENDIF(UNIX)
  # Install exe
  INSTALL(TARGETS ${exe}
    EXPORT OpenJPEGTargets
    DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
  )
ENDFOREACH(exe)

# Install man pages
INSTALL(
  FILES       ${OPENJPEG_SOURCE_DIR}/doc/man/man1/image_to_j2k.1
              ${OPENJPEG_SOURCE_DIR}/doc/man/man1/j2k_dump.1
              ${OPENJPEG_SOURCE_DIR}/doc/man/man1/j2k_to_image.1
  DESTINATION ${OPENJPEG_INSTALL_MAN_DIR}/man1)
#

IF(BUILD_JPWL)
  ADD_EXECUTABLE(JPWL_j2k_to_image
  j2k_to_image.c
  ${common_SRCS}
  )
  
  SET_PROPERTY(
     TARGET JPWL_j2k_to_image
     APPEND PROPERTY COMPILE_DEFINITIONS USE_JPWL
  )

  TARGET_LINK_LIBRARIES(JPWL_j2k_to_image ${OPENJPEG_LIBRARY_NAME}_JPWL
    ${LCMS_LIBNAME} ${PNG_LIBNAME} ${TIFF_LIBNAME})
    
  # To support universal exe:
  IF(ZLIB_FOUND AND APPLE)
    TARGET_LINK_LIBRARIES(JPWL_j2k_to_image z)
  ELSe(ZLIB_FOUND AND APPLE)
    TARGET_LINK_LIBRARIES(JPWL_j2k_to_image ${Z_LIBNAME})
  ENDIF(ZLIB_FOUND AND APPLE)
  
  IF(UNIX)
    TARGET_LINK_LIBRARIES(JPWL_j2k_to_image m)
  ENDIF(UNIX)

  ADD_EXECUTABLE(JPWL_image_to_j2k
  image_to_j2k.c
  ${common_SRCS}
  )
  
  SET_PROPERTY(
     TARGET JPWL_image_to_j2k
     APPEND PROPERTY COMPILE_DEFINITIONS USE_JPWL
  )

  TARGET_LINK_LIBRARIES(JPWL_image_to_j2k ${OPENJPEG_LIBRARY_NAME}_JPWL 
  	${LCMS_LIBNAME} ${PNG_LIBNAME} ${TIFF_LIBNAME})
  	
  # To support universal exe:
  IF(ZLIB_FOUND AND APPLE)
    TARGET_LINK_LIBRARIES(JPWL_image_to_j2k z)
  ELSe(ZLIB_FOUND AND APPLE)
    TARGET_LINK_LIBRARIES(JPWL_image_to_j2k ${Z_LIBNAME})
  ENDIF(ZLIB_FOUND AND APPLE)

  IF(UNIX)
    TARGET_LINK_LIBRARIES(JPWL_image_to_j2k m)
  ENDIF(UNIX)

  INSTALL(TARGETS JPWL_image_to_j2k JPWL_j2k_to_image
    DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
  )
ENDIF(BUILD_JPWL)

=== applications/mj2/CMakeLists.txt ===
# Makefile for the MJ2 codecs of the OpenJPEG library: frames_to_mj2, mj2_to_frames, extract_j2k_from_mj2 and wrap_j2k_in_mj2

SET(common_SRCS ${OPENJPEG_SOURCE_DIR}/applications/common/opj_getopt.c)

# While mj2 executables do not use the API correctly, we do not link with the library but rather compile the sources files.
SET(OPJ_SRCS
${OPENJPEG_SOURCE_DIR}/libopenjpeg/bio.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/cio.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/dwt.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/event.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/image.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/j2k.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/j2k_lib.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/jp2.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/jpt.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/mct.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/mqc.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/openjpeg.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/pi.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/raw.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/t1.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/t2.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/tcd.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/tgt.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/cidx_manager.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/phix_manager.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/ppix_manager.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/thix_manager.c
${OPENJPEG_SOURCE_DIR}/libopenjpeg/tpix_manager.c
)

SET(MJ2_SRCS mj2.c mj2_convert.c)

IF(WIN32)
  ADD_DEFINITIONS(-DOPJ_STATIC)
ENDIF(WIN32)

# Headers file are located here:
INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  ${OPENJPEG_SOURCE_DIR}/applications/common
  ${LCMS_INCLUDE_DIRNAME}
  )

ADD_EXECUTABLE(frames_to_mj2
  frames_to_mj2.c
  ${common_SRCS}
  ${OPJ_SRCS}
  ${MJ2_SRCS}
  )
TARGET_LINK_LIBRARIES(frames_to_mj2 ${LCMS_LIBNAME})

IF(UNIX)
  TARGET_LINK_LIBRARIES(frames_to_mj2 m)
ENDIF(UNIX)

ADD_EXECUTABLE(mj2_to_frames
    mj2_to_frames.c
    ${common_SRCS}
    ${OPJ_SRCS}
    ${MJ2_SRCS}
    ${OPENJPEG_SOURCE_DIR}/applications/common/color.c
    )
TARGET_LINK_LIBRARIES(mj2_to_frames ${LCMS_LIBNAME})

IF(UNIX)
  TARGET_LINK_LIBRARIES(mj2_to_frames m)
ENDIF(UNIX)

ADD_EXECUTABLE(extract_j2k_from_mj2
    extract_j2k_from_mj2.c
    ${OPJ_SRCS}
    ${MJ2_SRCS}
    )
TARGET_LINK_LIBRARIES(extract_j2k_from_mj2 ${LCMS_LIBNAME})

IF(UNIX)
  TARGET_LINK_LIBRARIES(extract_j2k_from_mj2 m)
ENDIF(UNIX)

ADD_EXECUTABLE(wrap_j2k_in_mj2
    wrap_j2k_in_mj2.c
    ${OPJ_SRCS}
    ${MJ2_SRCS}
    )
TARGET_LINK_LIBRARIES(wrap_j2k_in_mj2 ${LCMS_LIBNAME})

IF(UNIX)
  TARGET_LINK_LIBRARIES(wrap_j2k_in_mj2 m)
ENDIF(UNIX)

INSTALL(TARGETS frames_to_mj2 mj2_to_frames extract_j2k_from_mj2 wrap_j2k_in_mj2
	DESTINATION ${OPENJPEG_INSTALL_BIN_DIR})

=== tests/conformance/CMakeLists.txt ===
# CONFORMANCE TESTS AND NON-REGRESSION ON THIS DATASET

FILE(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Temporary)

SET(TEMP ${CMAKE_CURRENT_BINARY_DIR}/Temporary)
SET(BASELINE_CONF ${OPJ_DATA_ROOT}/baseline/conformance)
SET(BASELINE_NR ${OPJ_DATA_ROOT}/baseline/nonregression)
SET(INPUT_CONF ${OPJ_DATA_ROOT}/input/conformance)


# List of components by file (normaly p0_13.j2k have 257 components but for this 
#set of test we consider only 4)
SET( CP0_nbC_list "not_used;1;1;1;3;4;4;3;3;1;3;1;1;4;3;1;1")
SET( CP0_ignore_list "not_used;0;0;0;0;0;0;0;0;0;0;0;0;0;0;0;0")
SET( CP1_nbC_list "not_used;1;3;4;1;3;3;2")
SET( CP1_ignore_list "not_used;0;0;0;0;0;0;0")

SET(COMMENTCODEVAR FALSE)


#--------------------------------------------------------------------------
# Tests about class 0 profile 0
# try to decode
# compare to ref file provided by the Executable Test Suite
# non regression comparison

# Parameters and tolerances given by Table C.1
SET( C0P0_ResFactor_list "not_used;0;0;0;3;3;3;0;5;2;0;0;0;0;2;0;0")
SET( C0P0_PEAK_list "not_used;0;0;0;33;54;109;10;7;4;10;0;0;0;0;0;0")
SET( C0P0_MSE_list "not_used;0;0;0;55.8;68;743;0.34;6.72;1.47;2.84;0;0;0;0;0;0")

FOREACH(numFileC0P0 RANGE 1 16) 

list(GET CP0_ignore_list ${numFileC0P0}  ignore_test_value)
IF(ignore_test_value EQUAL 0)

  # Build filenames
  IF(${numFileC0P0} LESS 10)
    SET( filenameInput p0_0${numFileC0P0}.j2k )
    SET( filenameRef   c0p0_0${numFileC0P0}.pgx )
  ELSE(${numFileC0P0} LESS 10)
    SET( filenameInput p0_${numFileC0P0}.j2k )
    SET( filenameRef   c0p0_${numFileC0P0}.pgx )
  ENDIF(${numFileC0P0} LESS 10)
  
  # Get corresponding tests parameters
  list(GET C0P0_ResFactor_list ${numFileC0P0}  ResFactor)
  #For Class-0 testing, we always focus on the first component only
  #list(GET CP0_nbC_list ${numFileC0P0}  nbComponents)
  set( nbComponents "1")
  list(GET C0P0_PEAK_list ${numFileC0P0}  PEAK_limit)
  list(GET C0P0_MSE_list ${numFileC0P0}  MSE_limit)
  
  # Manage cases which need to try different resolution reduction
  IF (numFileC0P0 EQUAL 3 OR numFileC0P0 EQUAL 15)
    get_filename_component(filenameRefSub ${filenameRef} NAME_WE)
    #r = 0
    
    ADD_TEST(NAME ETS-C0P0-${filenameInput}-r0-decode 
        COMMAND j2k_to_image 
        -i ${INPUT_CONF}/${filenameInput}
        -o ${TEMP}/c0${filenameInput}-r0.pgx
        -r 0
        )
     
    ADD_TEST(NAME ETS-C0P0-${filenameInput}-r0-compare2ref
        COMMAND comparePGXimages
        -b ${BASELINE_CONF}/${filenameRefSub}r0.pgx
        -t ${TEMP}/c0${filenameInput}-r0.pgx
        -n ${nbComponents}
        -p ${PEAK_limit}
        -m ${MSE_limit}
        -s t_
        )
      
    SET_TESTS_PROPERTIES(ETS-C0P0-${filenameInput}-r0-compare2ref  
                         PROPERTIES DEPENDS 
                         ETS-C0P0-${filenameInput}-r0-decode)    
                       
    ADD_TEST(NAME NR-C0P0-${filenameInput}-r0-compare2base
        COMMAND comparePGXimages
        -b ${BASELINE_NR}/opj_${filenameRefSub}-r0.pgx
        -t ${TEMP}/c0${filenameInput}-r0.pgx
        -n ${nbComponents}
        -d 
        -s b_t_
        )
 
    SET_TESTS_PROPERTIES(NR-C0P0-${filenameInput}-r0-compare2base  
                         PROPERTIES DEPENDS 
                         ETS-C0P0-${filenameInput}-r0-decode)  
    
    #r = 1
    ADD_TEST(NAME ETS-C0P0-${filenameInput}-r1-decode
        COMMAND j2k_to_image 
        -i ${INPUT_CONF}/${filenameInput}
        -o ${TEMP}/c0${filenameInput}-r1.pgx
        -r 1
        )
     
    ADD_TEST(NAME ETS-C0P0-${filenameInput}-r1-compare2ref
        COMMAND comparePGXimages
        -b ${BASELINE_CONF}/${filenameRefSub}r1.pgx
        -t ${TEMP}/c0${filenameInput}-r1.pgx
        -n ${nbComponents}
        -p ${PEAK_limit}
        -m ${MSE_limit}
        -s t_
        )
      
    SET_TESTS_PROPERTIES(ETS-C0P0-${filenameInput}-r1-compare2ref  
                         PROPERTIES DEPENDS 
                         ETS-C0P0-${filenameInput}-r1-decode)    
                       
    ADD_TEST(NAME NR-C0P0-${filenameInput}-r1-compare2base
        COMMAND comparePGXimages
        -b ${BASELINE_NR}/opj_${filenameRefSub}-r1.pgx
        -t ${TEMP}/c0${filenameInput}-r1.pgx
        -n ${nbComponents}
        -d 
        -s b_t_
        )
 
    SET_TESTS_PROPERTIES(NR-C0P0-${filenameInput}-r1-compare2base  
                         PROPERTIES DEPENDS 
                         ETS-C0P0-${filenameInput}-r1-decode) 

  ELSE(numFileC0P0 EQUAL 3 OR numFileC0P0 EQUAL 15)
  
    ADD_TEST(NAME ETS-C0P0-${filenameInput}-decode
        COMMAND j2k_to_image 
        -i ${INPUT_CONF}/${filenameInput}
        -o ${TEMP}/c0${filenameInput}.pgx
        -r ${ResFactor}
        )
   
    ADD_TEST(NAME ETS-C0P0-${filenameInput}-compare2ref
        COMMAND comparePGXimages
        -b ${BASELINE_CONF}/${filenameRef}
        -t ${TEMP}/c0${filenameInput}.pgx
        -n ${nbComponents}
        -p ${PEAK_limit}
        -m ${MSE_limit}
        -s t_
        )
      
    SET_TESTS_PROPERTIES(ETS-C0P0-${filenameInput}-compare2ref  
                         PROPERTIES DEPENDS 
                         ETS-C0P0-${filenameInput}-decode)    
                       
    ADD_TEST(NAME NR-C0P0-${filenameInput}-compare2base
        COMMAND comparePGXimages
        -b ${BASELINE_NR}/opj_${filenameRef}
        -t ${TEMP}/c0${filenameInput}.pgx
        -n ${nbComponents}
        -d 
        -s b_t_
        )
 
    SET_TESTS_PROPERTIES(NR-C0P0-${filenameInput}-compare2base  
                         PROPERTIES DEPENDS 
                         ETS-C0P0-${filenameInput}-decode)    
      
  ENDIF(numFileC0P0 EQUAL 3 OR numFileC0P0 EQUAL 15)
  
  ENDIF(ignore_test_value EQUAL 0)

ENDFOREACH(numFileC0P0)

#--------------------------------------------------------------------------
# Tests about class 0 profile 1
# try to decode
# compare to ref file
# non regression comparison

# Parameters and tolerances given by Table C.4
SET( C0P1_ResFactor_list "not_used;0;3;3;0;4;1;0")
SET( C0P1_PEAK_list "not_used;0;35;28;2;128;128;0")
SET( C0P1_MSE_list "not_used;0;74;18.8;0.550;16384;16384;0")

FOREACH(numFileC0P1 RANGE 1 7) 

list(GET CP1_ignore_list ${numFileC0P1}  ignore_test_value2)
IF(ignore_test_value2 EQUAL 0)

  # Build filenames
  SET( filenameInput p1_0${numFileC0P1}.j2k )
  SET( filenameRef   c0p1_0${numFileC0P1}.pgx )

  # Get corresponding tests parameters 
  list(GET C0P1_ResFactor_list ${numFileC0P1}  ResFactor)
  #For Class-0 testing, we always focus on the first component only
  #list(GET CP0_nbC_list ${numFileC0P0}  nbComponents)
  set( nbComponents "1")
  list(GET C0P1_PEAK_list ${numFileC0P1}  PEAK_limit)
  list(GET C0P1_MSE_list ${numFileC0P1}  MSE_limit) 

  # Manage cases which need to try different resolution reduction
  IF (numFileC0P1 EQUAL 4 )
    get_filename_component(filenameRefSub ${filenameRef} NAME_WE)
    
    #r = 0
    ADD_TEST(NAME ETS-C0P1-${filenameInput}-r0-decode 
        COMMAND j2k_to_image 
        -i ${INPUT_CONF}/${filenameInput}
        -o ${TEMP}/c0${filenameInput}-r0.pgx
        -r 0
        )
    
    ADD_TEST(NAME ETS-C0P1-${filenameInput}-r0-compare2ref
        COMMAND comparePGXimages
        -b ${BASELINE_CONF}/${filenameRefSub}r0.pgx
        -t ${TEMP}/c0${filenameInput}-r0.pgx
        -n ${nbComponents}
        -p ${PEAK_limit}
        -m ${MSE_limit}
        -s t_
        )
      
    SET_TESTS_PROPERTIES(ETS-C0P1-${filenameInput}-r0-compare2ref  
                         PROPERTIES DEPENDS 
                         ETS-C0P1-${filenameInput}-r0-decode)    
                       
    ADD_TEST(NAME NR-C0P1-${filenameInput}-r0-compare2base
        COMMAND comparePGXimages
        -b ${BASELINE_NR}/opj_${filenameRefSub}-r0.pgx
        -t ${TEMP}/c0${filenameInput}-r0.pgx
        -n ${nbComponents}
        -d 
        -s b_t_
        )
 
    SET_TESTS_PROPERTIES(NR-C0P1-${filenameInput}-r0-compare2base  
                         PROPERTIES DEPENDS 
                         ETS-C0P1-${filenameInput}-r0-decode)
    
    #r = 3
    ADD_TEST(NAME ETS-C0P1-${filenameInput}-r3-decode
        COMMAND j2k_to_image 
        -i ${INPUT_CONF}/${filenameInput}
        -o ${TEMP}/c0${filenameInput}-r3.pgx
        -r 3
        )
        
    ADD_TEST(NAME ETS-C0P1-${filenameInput}-r3-compare2ref
        COMMAND comparePGXimages
        -b ${BASELINE_CONF}/${filenameRefSub}r3.pgx
        -t ${TEMP}/c0${filenameInput}-r3.pgx
        -n ${nbComponents}
        -p ${PEAK_limit}
        -m ${MSE_limit}
        -s t_
        )
      
    SET_TESTS_PROPERTIES(ETS-C0P1-${filenameInput}-r3-compare2ref  
                         PROPERTIES DEPENDS 
                         ETS-C0P1-${filenameInput}-r3-decode)    
                       
    ADD_TEST(NAME NR-C0P1-${filenameInput}-r3-compare2base
        COMMAND comparePGXimages
        -b ${BASELINE_NR}/opj_${filenameRefSub}-r3.pgx
        -t ${TEMP}/c0${filenameInput}-r3.pgx
        -n ${nbComponents}
        -d 
        -s b_t_
        )
 
    SET_TESTS_PROPERTIES(NR-C0P1-${filenameInput}-r3-compare2base  
                         PROPERTIES DEPENDS 
                         ETS-C0P1-${filenameInput}-r3-decode)
       
  ELSE(numFileC0P1 EQUAL 4)

    ADD_TEST(NAME ETS-C0P1-${filenameInput}-decode
        COMMAND j2k_to_image 
        -i ${INPUT_CONF}/${filenameInput}
        -o ${TEMP}/c0${filenameInput}.pgx
        -r ${ResFactor}
        )
            
    ADD_TEST(NAME ETS-C0P1-${filenameInput}-compare2ref
        COMMAND comparePGXimages
        -b ${BASELINE_CONF}/${filenameRef}
        -t ${TEMP}/c0${filenameInput}.pgx
        -n ${nbComponents}
        -p ${PEAK_limit}
        -m ${MSE_limit}
        -s t_
        )
      
    SET_TESTS_PROPERTIES(ETS-C0P1-${filenameInput}-compare2ref  
                         PROPERTIES DEPENDS 
                         ETS-C0P1-${filenameInput}-decode)    
                       
    ADD_TEST(NAME NR-C0P1-${filenameInput}-compare2base
        COMMAND comparePGXimages
        -b ${BASELINE_NR}/opj_${filenameRef}
        -t ${TEMP}/c0${filenameInput}.pgx
        -n ${nbComponents}
        -d 
        -s b_t_
        )
 
    SET_TESTS_PROPERTIES(NR-C0P1-${filenameInput}-compare2base  
                         PROPERTIES DEPENDS 
                         ETS-C0P1-${filenameInput}-decode)
            
  ENDIF(numFileC0P1 EQUAL 4)
  
    ENDIF(ignore_test_value2 EQUAL 0)

ENDFOREACH(numFileC0P1)

#--------------------------------------------------------------------------
# Tests about class 1 profile 0
# try to decode
# compare to ref file
# non regression comparison

# Parameters and tolerances given by Table C.6
SET( C1P0_ResFactor_list "not_used;0;0;0;0;0;0;0;1;0;0;0;0;0;0;0;0")
SET( C1P0_PEAK_list "not_used;0;0;0;5:4:6;2:2:2:0;635:403:378:0;0:0:0;0:0:0;0;0:0:0;0;0;0:0:0:0;0:0:0;0;0")
SET( C1P0_MSE_list  "not_used;0;0;0;0.776:0.626:1.070;0.302:0.307:0.269:0;11287:6124:3968:0;0:0:0;0:0:0;0;0:0:0;0;0;0:0:0:0;0:0:0;0;0")

FOREACH(numFileC1P0 RANGE 1 16) 

  # Build filenames
  IF(${numFileC1P0} LESS 10)
    SET( filenameInput p0_0${numFileC1P0}.j2k )
    SET( filenameRef   c1p0_0${numFileC1P0}.pgx )
  ELSE(${numFileC1P0} LESS 10)
    SET( filenameInput p0_${numFileC1P0}.j2k )
    SET( filenameRef   c1p0_${numFileC1P0}.pgx )
  ENDIF(${numFileC1P0} LESS 10)
  
  # Get corresponding tests parameters 
  list(GET CP0_nbC_list ${numFileC1P0}  nbComponents)
  list(GET C1P0_ResFactor_list ${numFileC1P0}  ResFactor)
  list(GET C1P0_PEAK_list ${numFileC1P0}  PEAK_limit)
  list(GET C1P0_MSE_list ${numFileC1P0}  MSE_limit)
  
  ADD_TEST(NAME ETS-C1P0-${filenameInput}-decode
      COMMAND j2k_to_image 
      -i ${INPUT_CONF}/${filenameInput}
      -o ${TEMP}/c1${filenameInput}.pgx
      -r ${ResFactor}
      )
      
  ADD_TEST(NAME ETS-C1P0-${filenameInput}-compare2ref
      COMMAND comparePGXimages
     -b ${BASELINE_CONF}/${filenameRef}
     -t ${TEMP}/c1${filenameInput}.pgx
     -n ${nbComponents}
     -p ${PEAK_limit}
     -m ${MSE_limit}
     -s b_t_
     )

=== tests/nonregression/CMakeLists.txt ===
# NON-REGRESSION TESTS ON THIS DATASET LOCATED ${OPJ_DATA_ROOT}/input/nonregression

FILE(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Temporary)

SET(TEMP ${CMAKE_CURRENT_BINARY_DIR}/Temporary)
SET(BASELINE_NR ${OPJ_DATA_ROOT}/baseline/nonregression)
SET(INPUT_NR ${OPJ_DATA_ROOT}/input/nonregression)

SET(INPUT_NR_PATH ${INPUT_NR})
SET(TEMP_PATH ${TEMP})

# need kdu_expand if possible
find_package(KAKADU)

#########################################################################
# GENERATION OF THE TEST SUITE
# Read one and more input file(s) (located in ${OPJ_DATA_ROOT}/input/nonregression) 
# to know which files processed and with which options.

# Configure the test suite file:
CONFIGURE_FILE("test_suite.ctest.in"
               "${CMAKE_CURRENT_BINARY_DIR}/test_suite.ctest"
               @ONLY)

# Read the file into a list
FILE(STRINGS ${CMAKE_CURRENT_BINARY_DIR}/test_suite.ctest OPJ_TEST_CMD_LINE_LIST)

# Try to find and configure and read another test suite file
FILE(GLOB TEST_SUITE_FILES *.ctest.in)
IF (TEST_SUITE_FILES)
  FOREACH(TEST_SUITE_FILE ${TEST_SUITE_FILES})
    
    # Avoid to process the official test suite
    SET(FILE_ALREADY_READ 0)
    STRING(REGEX MATCH "test_suite.ctest.in$" FILE_ALREADY_READ ${TEST_SUITE_FILE})
   
    IF(NOT FILE_ALREADY_READ) 
      # Configure the additional test suite file:
      GET_FILENAME_COMPONENT(TEST_SUITE_FILE_SUB ${TEST_SUITE_FILE} NAME_WE)
      CONFIGURE_FILE("${TEST_SUITE_FILE}"
                     "${CMAKE_CURRENT_BINARY_DIR}/${TEST_SUITE_FILE_SUB}.ctest"
                     @ONLY)
      # Read the additional file into a list
      FILE(STRINGS ${CMAKE_CURRENT_BINARY_DIR}/${TEST_SUITE_FILE_SUB}.ctest OPJ_TEST_CMD_LINE_LIST_TEMP)
      # Append the list of command
      SET(OPJ_TEST_CMD_LINE_LIST ${OPJ_TEST_CMD_LINE_LIST} ${OPJ_TEST_CMD_LINE_LIST_TEMP}) 
    
    ENDIF(NOT FILE_ALREADY_READ) 

  ENDFOREACH(TEST_SUITE_FILE)
  
ELSE(TEST_SUITE_FILES)

  MESSAGE(FATAL_ERROR "One test suite should be available (test_suite.ctest.in) !!!")
  
ENDIF(TEST_SUITE_FILES)


# Parse the command line found in the file(s)
SET(IT_TEST_ENC 0)
SET(IT_TEST_DEC 0)
FOREACH(OPJ_TEST_CMD_LINE ${OPJ_TEST_CMD_LINE_LIST})
  
  SET(IGNORE_LINE_FOUND 0)

  # Replace space by ; to generate a list
  STRING(REPLACE " " ";" CMD_ARG_LIST ${OPJ_TEST_CMD_LINE})
  
  # Check if the first argument begin by the comment sign
  LIST(GET CMD_ARG_LIST 0 EXE_NAME)
  STRING(REGEX MATCH "^#" IGNORE_LINE_FOUND ${EXE_NAME})
 
  IF(IGNORE_LINE_FOUND) 
    
    #MESSAGE( STATUS "Current line is ignored: ${OPJ_TEST_CMD_LINE}")
   
  ELSE(IGNORE_LINE_FOUND)
  
    # Check if the first argument begin by the failed sign
    SET(FAILED_TEST_FOUND 0)
    STRING(REGEX MATCH "^!" FAILED_TEST_FOUND ${EXE_NAME})
   
    IF (FAILED_TEST_FOUND)
      # Manage the different cases with the failed sign to remove the first argument which must be image_to_j2k
      SET(FAILED_TEST_FOUND_1 0)
      STRING(REGEX MATCH "^!image_to_j2k$|^!j2k_to_image$" FAILED_TEST_FOUND_1 ${EXE_NAME})
      
      IF (FAILED_TEST_FOUND_1)
        
        LIST(REMOVE_AT CMD_ARG_LIST 0)
      
      ELSE (FAILED_TEST_FOUND_1)
        
        SET(FAILED_TEST_FOUND_2 0)
        LIST(GET CMD_ARG_LIST 1 EXE_NAME)
        STRING(REGEX MATCH "^image_to_j2k$|^j2k_to_image$" FAILED_TEST_FOUND_2 ${EXE_NAME})
      
        IF (FAILED_TEST_FOUND_2)
        
          LIST(REMOVE_AT CMD_ARG_LIST 0)
          LIST(REMOVE_AT CMD_ARG_LIST 0)
      
        ELSE (FAILED_TEST_FOUND_2)
        
          MESSAGE( FATAL_ERROR "${EXE_NAME} is not the right executable name to encode file (try to use image_to_j2k or j2k_to_image)")
          
        ENDIF (FAILED_TEST_FOUND_2)
      ENDIF (FAILED_TEST_FOUND_1)
      
    ELSE (FAILED_TEST_FOUND)
      # Check if the first argument is equal to image_to_j2k
      STRING(REGEX MATCH "^image_to_j2k$|^j2k_to_image$" EXE_NAME_FOUND ${EXE_NAME})
      
      IF(EXE_NAME_FOUND)
      
        STRING(REGEX MATCH "image_to_j2k" ENC_TEST_FOUND ${EXE_NAME})
     
      ELSE(EXE_NAME_FOUND)
        
        MESSAGE( FATAL_ERROR "${EXE_NAME} is not the right executable name to encode file (try to use image_to_j2k)")
        
      ENDIF(EXE_NAME_FOUND)
      
      LIST(REMOVE_AT CMD_ARG_LIST 0)
      
    ENDIF (FAILED_TEST_FOUND)
  
    # Parse the argument list to find the input filename and output filename
    SET(CMD_ARG_LIST_2 "")
    SET(ARG_POS 0)
    SET(INPUT_ARG_POS 0)
    SET(OUTPUT_ARG_POS 0)
        
    FOREACH(CMD_ARG_ELT ${CMD_ARG_LIST})
      
      math(EXPR ARG_POS "${ARG_POS}+1" ) 

      STRING(COMPARE EQUAL ${CMD_ARG_ELT} "-i" INPUT_ARG_FOUND)
      IF(INPUT_ARG_FOUND)
        SET(INPUT_ARG_POS ${ARG_POS})
        SET(INPUT_ARG_FOUND 0)
      ENDIF(INPUT_ARG_FOUND)
      
      STRING(COMPARE EQUAL ${CMD_ARG_ELT} "-o" OUTPUT_ARG_FOUND)
      IF(OUTPUT_ARG_FOUND)
        SET(OUTPUT_ARG_POS ${ARG_POS})
        SET(OUTPUT_ARG_FOUND 0)
      ENDIF(OUTPUT_ARG_FOUND)
      
      LIST (APPEND CMD_ARG_LIST_2 ${CMD_ARG_ELT})
  
    ENDFOREACH(CMD_ARG_ELT)
  
    LIST(GET CMD_ARG_LIST_2 ${INPUT_ARG_POS} INPUT_FILENAME)
    GET_FILENAME_COMPONENT(INPUT_FILENAME_NAME ${INPUT_FILENAME} NAME)
    GET_FILENAME_COMPONENT(INPUT_FILENAME_NAME_WE ${INPUT_FILENAME_NAME} NAME_WE)
    LIST(GET CMD_ARG_LIST_2 ${OUTPUT_ARG_POS} OUTPUT_FILENAME)
    GET_FILENAME_COMPONENT(OUTPUT_FILENAME_NAME_WE ${OUTPUT_FILENAME} NAME_WE)
    
    #-----
    # Now we can add the test suite corresponding to a line command in the file
    #-----
    
    # ENCODER TEST SUITE
    IF(ENC_TEST_FOUND)
        math(EXPR IT_TEST_ENC "${IT_TEST_ENC}+1" )
        
        # Encode an image into the jpeg2000 format
        ADD_TEST(NAME NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-encode
          COMMAND image_to_j2k
          ${CMD_ARG_LIST_2}
        )
        
        IF(FAILED_TEST_FOUND)
            SET_TESTS_PROPERTIES(NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-encode PROPERTIES WILL_FAIL TRUE)
        ELSE(FAILED_TEST_FOUND)
          
          # Dump the encoding file 
          ADD_TEST(NAME NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-dump
            COMMAND j2k_dump
            -i ${OUTPUT_FILENAME}
            -o ${OUTPUT_FILENAME}-ENC-${IT_TEST_ENC}.txt
          )
          SET_TESTS_PROPERTIES(NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-dump
                               PROPERTIES DEPENDS 
                               NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-encode) 
        
          # Compare the dump file with the baseline 
          ADD_TEST(NAME NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-compare_dump2base
            COMMAND compare_dump_files
            -b ${BASELINE_NR}/opj_${OUTPUT_FILENAME_NAME_WE}-ENC-${IT_TEST_ENC}.txt
            -t ${OUTPUT_FILENAME}-ENC-${IT_TEST_ENC}.txt
          )
        
          SET_TESTS_PROPERTIES(NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-compare_dump2base
                               PROPERTIES DEPENDS 
                               NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-dump) 
    
          # Decode the encoding file with kakadu expand command
          IF (KDU_EXPAND_EXECUTABLE)
            ADD_TEST(NAME NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-decode-ref
              COMMAND ${KDU_EXPAND_EXECUTABLE}
              -i ${OUTPUT_FILENAME}
              -o ${OUTPUT_FILENAME}.raw
              )
        
            SET_TESTS_PROPERTIES(NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-decode-ref
                                 PROPERTIES DEPENDS 
                                 NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-encode) 
        
            # Compare the decoding file with baseline generated from the kdu_expand and baseline.j2k 
            ADD_TEST(NAME NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-compare_dec-ref-out2base
              COMMAND compareRAWimages
              -b ${BASELINE_NR}/opj_${OUTPUT_FILENAME_NAME_WE}-ENC-${IT_TEST_ENC}.raw
              -t ${OUTPUT_FILENAME}.raw
            )
        
            SET_TESTS_PROPERTIES(NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-compare_dec-ref-out2base
                                 PROPERTIES DEPENDS 
                                 NR-ENC-${INPUT_FILENAME_NAME}-${IT_TEST_ENC}-decode-ref)
        
          ENDIF()
      ENDIF(FAILED_TEST_FOUND)     
    
    # DECODER TEST SUITE
    ELSE(ENC_TEST_FOUND)
      math(EXPR IT_TEST_DEC "${IT_TEST_DEC}+1" )
      
      # Decode the input image
      ADD_TEST(NAME NR-DEC-${INPUT_FILENAME_NAME}-${IT_TEST_DEC}-decode
        COMMAND j2k_to_image 
        ${CMD_ARG_LIST_2}
      )
      
      IF(FAILED_TEST_FOUND)
      
        SET_TESTS_PROPERTIES(NR-DEC-${INPUT_FILENAME_NAME}-${IT_TEST_DEC}-decode PROPERTIES WILL_FAIL TRUE)
     
      ELSE(FAILED_TEST_FOUND)
        # if not failed, check against registered md5:
        add_test(NAME NR-DEC-${INPUT_FILENAME_NAME}-${IT_TEST_DEC}-decode-md5 COMMAND ${CMAKE_COMMAND}
          -DREFFILE:STRING=${CMAKE_CURRENT_SOURCE_DIR}/md5refs.txt
          -DFILENAME:STRING=${INPUT_FILENAME_NAME}
          -P ${CMAKE_CURRENT_SOURCE_DIR}/checkmd5refs.cmake)

# FIXME: add a compare2base function base on raw which 
# can output png diff files if necesary 
#  ADD_TEST(NAME NR-${filename}-compare2base
#      COMMAND comparePGXimages
#     -b ${BASELINE_NR}/opj_${filenameRef}
#     -t ${TEMP}/${filename}.pgx
#     -n ${nbComponents}
#     -d 
#     -s b_t_
#     )
#
#  SET_TESTS_PROPERTIES(NR-${filename}-compare2base  
#                       PROPERTIES DEPENDS 
#                       NR-${filename}-decode)  
    
        # Dump the input image
        ADD_TEST(NAME NR-DEC-${INPUT_FILENAME_NAME}-${IT_TEST_DEC}-dump
          COMMAND j2k_dump
          -i ${INPUT_FILENAME}
          -o ${TEMP}/${INPUT_FILENAME_NAME}.txt
        )
     
        # Compare the dump output with the baseline
        ADD_TEST(NAME NR-DEC-${INPUT_FILENAME_NAME}-${IT_TEST_DEC}-compare_dump2base
          COMMAND compare_dump_files
         -b ${BASELINE_NR}/opj_${INPUT_FILENAME_NAME_WE}.txt
         -t ${TEMP}/${INPUT_FILENAME_NAME}.txt
        )
     
        SET_TESTS_PROPERTIES(NR-DEC-${INPUT_FILENAME_NAME}-${IT_TEST_DEC}-compare_dump2base  
                             PROPERTIES DEPENDS 
                             NR-DEC-${INPUT_FILENAME_NAME}-${IT_TEST_DEC}-dump)     
  

      ENDIF(FAILED_TEST_FOUND)    
  
    ENDIF(ENC_TEST_FOUND)
   
  ENDIF(IGNORE_LINE_FOUND)

ENDFOREACH(OPJ_TEST_CMD_LINE)

=== tests/unit/CMakeLists.txt ===
# UNIT TESTS 

add_executable(testempty1 testempty1.c)
add_executable(testempty2 testempty2.c)
target_link_libraries(testempty1 openjpeg)
target_link_libraries(testempty2 openjpeg)

add_test(NAME testempty1 COMMAND testempty1)
add_test(NAME testempty2 COMMAND testempty2)

=== applications/jpip/libopenjpip/CMakeLists.txt ===
INCLUDE_REGULAR_EXPRESSION("^.*$")

INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/libopenjpeg
  ${FCGI_INCLUDE_DIRS}
  ${CURL_INCLUDE_DIRS}
)

# Defines the source code for the library
SET(OPENJPIP_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/boxheader_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/codestream_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/imgreg_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/marker_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/msgqueue_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/box_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/faixbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/index_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/metadata_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/placeholder_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/byte_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/ihdrbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/manfbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/mhixbox_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/target_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cachemodel_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/j2kheader_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/jp2k_encoder.c
  ${CMAKE_CURRENT_SOURCE_DIR}/openjpip.c
  ${CMAKE_CURRENT_SOURCE_DIR}/query_parser.c
  ${CMAKE_CURRENT_SOURCE_DIR}/channel_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/session_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/jpip_parser.c
  ${CMAKE_CURRENT_SOURCE_DIR}/sock_manager.c
  )

SET(SERVER_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/auxtrans_manager.c
  )

SET(LOCAL_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/jp2k_decoder.c
  ${CMAKE_CURRENT_SOURCE_DIR}/imgsock_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/jpipstream_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/cache_manager.c
  ${CMAKE_CURRENT_SOURCE_DIR}/dec_clientmsg_handler.c
  )

# Build the library
ADD_LIBRARY(openjpip_local STATIC ${OPENJPIP_SRCS} ${LOCAL_SRCS})
TARGET_LINK_LIBRARIES(openjpip_local ${OPENJPEG_LIBRARY_NAME})
IF(WIN32)
  # add Winsock on windows+mingw
  TARGET_LINK_LIBRARIES(openjpip_local ws2_32)
ENDIF(WIN32)

# Install library
INSTALL(TARGETS openjpip_local
  EXPORT OpenJPEGTargets
  DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
  )

IF(BUILD_JPIP_SERVER)
  ADD_LIBRARY(openjpip_server STATIC ${OPENJPIP_SRCS} ${SERVER_SRCS})
  TARGET_LINK_LIBRARIES(openjpip_server ${FCGI_LIBRARIES} ${CURL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
  SET_TARGET_PROPERTIES(openjpip_server
    PROPERTIES COMPILE_FLAGS "-DSERVER")
  INSTALL(TARGETS openjpip_server
    EXPORT OpenJPEGTargets
    DESTINATION ${OPENJPEG_INSTALL_LIB_DIR} COMPONENT Libraries
    )
ENDIF(BUILD_JPIP_SERVER)

=== applications/jpip/util/CMakeLists.txt ===
# Headers file are located here:
INCLUDE_DIRECTORIES(
  ${OPENJPEG_SOURCE_DIR}/applications/jpip/libopenjpip
  ${FCGI_INCLUDE_DIRS}
)

# Tool to embed metadata into JP2 file
ADD_EXECUTABLE(addXMLinJP2 addXMLinJP2.c)
# Install exe
INSTALL(TARGETS addXMLinJP2
  EXPORT OpenJPEGTargets
  DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
  )

IF(BUILD_JPIP_SERVER)
  
  SET(OPJ_SERVER_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/opj_server.c
  )
  
  # Build executable
  ADD_EXECUTABLE(opj_server ${OPJ_SERVER_SRCS})
  TARGET_LINK_LIBRARIES(opj_server openjpip_server)
  SET_PROPERTY(
    TARGET opj_server
    APPEND PROPERTY
    COMPILE_DEFINITIONS SERVER QUIT_SIGNAL="quitJPIP"
    )

  # On unix you need to link to the math library:
  IF(UNIX)
    TARGET_LINK_LIBRARIES(opj_server m)
  ENDIF(UNIX)

  # Install exe
  INSTALL(TARGETS opj_server
    EXPORT OpenJPEGTargets
    DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
    )
ENDIF(BUILD_JPIP_SERVER)

SET(EXES
  opj_dec_server
  jpip_to_jp2
  jpip_to_j2k
  test_index
  )
FOREACH(exe ${EXES})
  ADD_EXECUTABLE(${exe} ${exe}.c)
  TARGET_LINK_LIBRARIES(${exe} openjpip_local)
  INSTALL(TARGETS ${exe}
    EXPORT OpenJPEGTargets
    DESTINATION ${OPENJPEG_INSTALL_BIN_DIR} COMPONENT Applications
    )
ENDFOREACH(exe)

# Build the two java clients:
FIND_PACKAGE(Java 1.5 COMPONENTS Development) # javac, jar

# User can override this:
if(NOT DEFINED JAVA_SOURCE_VERSION) 
  set(JAVA_SOURCE_VERSION 1.5)
endif()
if(NOT DEFINED JAVA_TARGET_VERSION)
  set(JAVA_TARGET_VERSION 1.5)
endif()

# Only build the java viewer if dev is found:
if(Java_Development_FOUND AND Java_JAVAC_EXECUTABLE)
  set(jflags $ENV{JFLAGS})
  # 1. opj_viewer
  # build dep list:
  file(GLOB java1_srcs "opj_viewer/src/*.java")

  # make sure target javac dir exists:
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classes1)
  # Build java
  ADD_CUSTOM_COMMAND(
    OUTPUT ${LIBRARY_OUTPUT_PATH}/opj_viewer.jar
    COMMAND ${Java_JAVAC_EXECUTABLE} ${jflags}
    -source ${JAVA_SOURCE_VERSION} -target ${JAVA_TARGET_VERSION}
    ${java1_srcs} -d ${CMAKE_CURRENT_BINARY_DIR}/classes1
    COMMAND ${Java_JAR_EXECUTABLE} cfm ${LIBRARY_OUTPUT_PATH}/opj_viewer.jar
    ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/dist/manifest.txt -C
    ${CMAKE_CURRENT_BINARY_DIR}/classes1 .
    DEPENDS ${java1_srcs}
    ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/dist/manifest.txt
    COMMENT "javac *.java; jar cvf -> opj_viewer.jar"
    )

  # name the target
  ADD_CUSTOM_TARGET(OPJViewerJar ALL
    DEPENDS ${LIBRARY_OUTPUT_PATH}/opj_viewer.jar
    COMMENT "building opj_viewer.jar"
    )

  INSTALL(FILES ${LIBRARY_OUTPUT_PATH}/opj_viewer.jar
    DESTINATION ${OPENJPEG_INSTALL_SHARE_DIR} COMPONENT JavaModule
    )

  # 2. opj_viewer_xerces
  # search for package org.apache.xerces.parsers
  find_file(APACHE_XERCES_JAR
    NAMES xerces-j2.jar xercesImpl.jar
    PATHS /usr/share/java/
    NO_DEFAULT_PATH
    )
  mark_as_advanced(APACHE_XERCES_JAR)

  if(EXISTS ${APACHE_XERCES_JAR})
    configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer_xerces/dist/manifest.txt.in
      ${CMAKE_CURRENT_BINARY_DIR}/opj_viewer_xerces/dist/manifest.txt
      @ONLY
      )
    # build dep list:
    file(GLOB java2_srcs "opj_viewer_xerces/src/*.java")

    # Need some common files:
    list(APPEND java2_srcs
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/ImageManager.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/ImgdecClient.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/JPIPHttpClient.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/MML.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/PnmImage.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/RegimViewer.java
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer/src/ResizeListener.java
      )

    # make sure target javac dir exists:
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/classes2)
    # Build java
    ADD_CUSTOM_COMMAND(
      OUTPUT ${LIBRARY_OUTPUT_PATH}/opj_viewer_xerces.jar
      COMMAND ${Java_JAVAC_EXECUTABLE} ${jflags}
      -source ${JAVA_SOURCE_VERSION} -target ${JAVA_TARGET_VERSION}
      -classpath ${APACHE_XERCES_JAR}
      ${java2_srcs} -d ${CMAKE_CURRENT_BINARY_DIR}/classes2
      COMMAND ${Java_JAR_EXECUTABLE} cfm ${LIBRARY_OUTPUT_PATH}/opj_viewer_xerces.jar
      ${CMAKE_CURRENT_BINARY_DIR}/opj_viewer_xerces/dist/manifest.txt 
      -C ${CMAKE_CURRENT_BINARY_DIR}/classes2 .
      DEPENDS ${java2_srcs}
      ${CMAKE_CURRENT_SOURCE_DIR}/opj_viewer_xerces/dist/manifest.txt.in
      COMMENT "javac *.java; jar cvf -> opj_viewer_xerces.jar"
      )

    # name the target
    ADD_CUSTOM_TARGET(OPJViewerXercesJar ALL
      DEPENDS ${LIBRARY_OUTPUT_PATH}/opj_viewer_xerces.jar
      COMMENT "building opj_viewer_xerces.jar"
      )

    INSTALL(FILES ${LIBRARY_OUTPUT_PATH}/opj_viewer_xerces.jar
      DESTINATION ${OPENJPEG_INSTALL_SHARE_DIR} COMPONENT JavaModule
      )
  endif()
else(Java_Development_FOUND)
  message(WARNING "No java compiler found. Wont be able to build java viewer")
endif()

=== debian/changelog ===
openjpeg (1:1.5.2-3.1) unstable; urgency=high

  * Non-maintainer upload.
  * Apache 2.4 transition: (Closes: #786332)
    - d/openjpip.conf: Changed documentroot path to /var/www/html;
      changed localhost by 127.0.0.1 to support ipv6 enabled hosts.
    - Use dh_apache2:
      . d/rules: Added --with apache2.
      . d/openjpip-server.install: Drop installs to /etc/apache2/mods-available
      . Drop d/openjpip-server.prerm.
      . d/control: Add build-depends on dh-apache2, replace depends on
        apache2.2-bin by ${misc:Recommends}, add recommends on
        libapache2-mod-fastcgi.
      . New d/openjpip-server.apache2 to set up the configuration.
      . Install as a conf-available: Renamed openjpip.conf to
        openjpip-server.conf, removed openjpip.load, new maintscript.

 -- Jean-Michel Vourgère <nirgal@debian.org>  Wed, 20 May 2015 21:52:22 +0200

openjpeg (1:1.5.2-3) unstable; urgency=medium

  * epoch upload to resolve #760874 completely

 -- Mathieu Malaterre <malat@debian.org>  Sat, 04 Oct 2014 13:51:19 +0200

openjpeg (1.5.2-2) unstable; urgency=low

  * Remove patch applied upstream already
    - d/p/fixjnisoname.patch
  * Really fix java compilation. Closes: #741915
  * Use system installed getopt. Closes: #716594
  * Update d/copyright. Closes: #697806

 -- Mathieu Malaterre <malat@debian.org>  Tue, 01 Apr 2014 13:38:56 +0000

openjpeg (1.5.2-1) unstable; urgency=low

  * New upstream.
    Closes: #731237, #697806, #716594, #716595, #741915, #741974, #741916
  * Update watch file to now point to sf.net mirror

 -- Mathieu Malaterre <malat@debian.org>  Thu, 27 Mar 2014 20:19:41 +0100

openjpeg (1.5.1-3) unstable; urgency=low

  * Fix cmake monolithic export.
  * Prefer build type of None
  * B-D on libtiff-dev. Closes: #736034

 -- Mathieu Malaterre <malat@debian.org>  Mon, 17 Mar 2014 18:45:54 +0100

openjpeg (1.5.1-2) unstable; urgency=low

  * Upload to sid
  * Import patch from upstream to prevent regression from 1.5.0:
    d/p/issue205.patch

 -- Mathieu Malaterre <malat@debian.org>  Mon, 17 Mar 2014 09:28:46 +0100

openjpeg (1.5.1-1) experimental; urgency=low

  * New upstream. Closes: #687528, #681458, #691156
  * Fix java binding installation
    - fixjniinstall.patch
  * Fix SONAME hack in d/rules, prefer cmake solution
    - fixjnisoname.patch
  * Remove patch applied upstream:
    - addmathlib.patch
    - fixsoname.patch
    - relativeincludepath.patch
    - installjava.patch
    - addxml2.patch
    - manpagetypo.patch

 -- Mathieu Malaterre <malat@debian.org>  Mon, 22 Oct 2012 12:51:26 +0200

openjpeg (1.5.0-3) experimental; urgency=low

  * Add missing jp2-thumbnailer
  * Mark packages with Multi-Arch: same/foreign

 -- Mathieu Malaterre <malat@debian.org>  Tue, 19 Jun 2012 16:46:59 +0200

openjpeg (1.5.0-2) experimental; urgency=low

  * Adding libopenjpeg-java. Closes: #510443
  * Update d/control so that it is easier to backport to stable
  * Provide a fix for cmake commit a2be068c
  * Provide a symlinks openjpeg.h -> openjpeg-1.5/openjpeg.h for easier
    transition
  * Add openjpip-server package: openjpip-server
   - Add init script
   - Fix default location of tempfile to be in /tmp
  * Add openjpip java based clients packages:
   - openjpip-viewer
   - openjpip-viewer-xerces

 -- Mathieu Malaterre <malat@debian.org>  Fri, 20 Apr 2012 11:45:07 +0200

=== debian/control ===
Source: openjpeg
Priority: extra
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders:
 Robin Cornelius <robin.cornelius@gmail.com>
 , David Paleino <dapal@debian.org>
 , Mathieu Malaterre <malat@debian.org>
Homepage: http://www.openjpeg.org
Build-Depends:
 debhelper (>= 9)
 , dh-apache2
 , cmake (>= 2.8.0)
 , javahelper (>= 0.37~)
 , default-jdk
 , libxerces2-java
 , libtiff-dev
 , libpng-dev
 , liblcms2-dev
 , zlib1g-dev
 , libfcgi-dev
 , libcurl4-gnutls-dev | libcurl-ssl-dev
 , doxygen
Standards-Version: 3.9.5
Section: libs
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-phototools/openjpeg.git
Vcs-Git: git://anonscm.debian.org/pkg-phototools/openjpeg.git

Package: libopenjpeg-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libopenjpeg5 (= ${binary:Version})
 , ${misc:Depends}
Description: development files for OpenJPEG, a JPEG 2000 image library - dev
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 This is the development package

Package: libopenjpeg5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}
 , ${misc:Depends}
Description: JPEG 2000 image compression/decompression library - runtime
 OpenJPEG is a library for handling the JPEG 2000 image compression format.
 JPEG 2000 is a wavelet-based image compression standard and permits progressive
 transmission by pixel and resolution accuracy for progressive downloads of an
 encoded image. It supports lossless and lossy compression, supports higher
 compression than JPEG 1991, and has resilience to errors in the image.
 .
 this is the runtime package

Package: libopenjpeg-java
Section: java
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, ${java:Depends}
Description: java bindings for libopenjpeg, a JPEG 2000 image library
 This package contains the java binding to match the runtime component of the
 OpenJPEG library, allowing java program to use OpenJPEG.
 .
 This is a Java bindings to the underlying OpenJPEG C implementation. This
 is not a full Java implementation.

Package: libopenjpeg5-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: libopenjpeg5 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for libopenjpeg5, a JPEG 2000 image library
 This package contains the debug symbols to match the runtime component of the
 OpenJPEG library, allowing debugging of a program using OpenJPEG to
 access debugging details within the library itself.

Package: openjpip-dec-server
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to allow caching of JPEG 2000 files using JPIP protocol
 This is client side application for caching remote JPEG 2000 using the JPIP
 protocol. This command line application needs to run on the client side to
 allow application such as opj_viewer or opj_viewer_xerces to view images.

Package: openjpip-viewer-xerces
Section: graphics
Architecture: all
Depends: ${misc:Depends}, ${java:Depends}, openjpip-dec-server
Description: JPEG 2000 java based viewer for advanced remote JPIP access
 Java based client to view remote JPEG 2000 using JPIP protocol.
 This is a simple java viewer to allow:
 .
  - Scale up request: Enlarge the window
  - ROI request: Select a region by mouse click and drag, then click inside the
    red frame of the selected region
  - Annotate image with ROI information in XML metadata: Click button "Region
    Of Interest"
  - Open a new window presenting an aligned image with a locally stored image:
    Click button "Image Registration" (Under Construction)

Package: openjpip-viewer
Section: graphics
Architecture: all
Depends: ${misc:Depends}, ${java:Depends}, openjpip-dec-server
Description: JPEG 2000 java based viewer for basic remote JPIP access
 Java based client to view remote JPEG 2000 using JPIP protocol.
 This is a simple java viewer to allow:
 .
  - Scale up request: Enlarge the window
  - ROI request: Select a region by mouse click and drag, then click inside the
    red frame of the selected region

Package: openjpip-server
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libwww-perl, spawn-fcgi (>= 1.6.1)
Recommends: ${misc:Recommends}, libapache2-mod-fastcgi
Description: JPIP server for JPEG 2000 files
 OpenJPIP software is an implementation of JPEG 2000 Part9: Interactivity tools,
 APIs and protocols (JPIP). For more info about JPIP, check the website:
 http://www.jpeg.org/jpeg2000/j2kpart9.html. The current implementation uses
 some results from the 2KAN project (http://www.2kan.org).
 .
 First Version 1.0 covers:
 .
  - JPT-stream (Tile based) and JPP-stream (Precinct based) media types
  - Session, channels, cache model managements
  - JPIP over HTTP
  - Indexing JPEG 2000 files
  - Embedding XML formatted metadata
  - Region Of Interest (ROI) requests

Package: openjpeg-tools
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: command-line tools using the JPEG 2000 library
 This package provides with command-line tools allowing for conversions between
 several formats and also provides tools for encoding and decoding
 motion-jpeg2000 video formats:
 .
  - j2k_to_image: decodes j2k, jp2, and jpt files to pgm, ppm, pnm,
                  pgx, and bmp.
  - image_to_j2k: encodes pnm, pgm, pgx, bmp, and ppm files to j2k,
                  and jp2.
  - index_create: create jp2 with JPIP index file from a j2k file.
  - frames_to_mj2: convert YUV video streams to mj2 format.
  - mj2_to_frames: convert mj2 video streams to YUV format.
  - wrap_j2k_in_mj2: wrap j2k codestreams into mj2 format.
  - extract-j2k-from_mj2: extract j2k codestreams from the mj2 format.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CURVER := $(shell dpkg-parsechangelog | grep ^Version | awk '{print $$2}' | cut -d- -f1 | cut -d+ -f1)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
JAVA_HOME=/usr/lib/jvm/default-java

%:
	dh $@ --buildsystem=cmake --parallel --with javahelper,apache2

CMAKE_EXTRA_FLAGS += -DCMAKE_SKIP_RPATH=ON \
	-DCMAKE_BUILD_TYPE:STRING=None \
	-DOPENJPEG_INSTALL_LIB_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
	-DOPENJPEG_INSTALL_JNI_DIR:STRING=lib/$(DEB_HOST_MULTIARCH)/jni \
	-DBUILD_CODEC:BOOL=ON \
	-DBUILD_JPIP:BOOL=ON \
	-DBUILD_JPIP_SERVER:BOOL=ON \
	-DBUILD_JPWL:BOOL=ON \
	-DBUILD_JAVA:BOOL=ON \
	-DBUILD_MJ2:BOOL=ON \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DUSE_SYSTEM_GETOPT:BOOL=ON \
	-DBUILD_TESTING:BOOL=OFF \
	-DBUILD_THIRDPARTY:BOOL=OFF

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_strip:
	dh_strip --dbg-package=libopenjpeg5-dbg

override_dh_install:
	dh_install --list-missing

override_dh_installinit:
	dh_installinit -popenjpip-server --name=openjpip

# http://cmake.org/gitweb?p=cmake.git;a=commitdiff;h=a2be068c
override_dh_auto_install:
	sed -i -e "s/FATAL_ERROR/STATUS/g" ./obj-*/CMakeFiles/Export/lib/*/openjpeg-1.5/OpenJPEGTargets-none.cmake
	sed -i -e "s/FATAL_ERROR/STATUS/g" ./obj-*/CMakeFiles/Export/lib/*/openjpeg-1.5/OpenJPEGTargets.cmake
	dh_auto_install

get-orig-source:
	uscan --verbose --rename \
		--force-download \
		--download-version $(CURVER)

.PHONY: override_dh_auto_configure \
	override_dh_strip \
	get-orig-source

=== debian/watch ===
version=3
http://sf.net/openjpeg.mirror/openjpeg-([\d\.]+)\.tar\.gz \
debian debian/orig-tar.sh
